var SYS_URL_PREFIX = "http://localhost/~pncreaderjs";

var HttpHelper = {
    invokeObj: function() {
        if (arguments.length < 3) return;

        var requestName = arguments[0];
        var functionName = arguments[1];
        var callback = arguments[arguments.length - 1];
        var args = Array.prototype.slice.call(arguments, 2, arguments.length - 1);

		var body = JSON.stringify(args);
        
        var url = SYS_URL_PREFIX + "/" + requestName + "/" + functionName;
        
        var request = new XMLHttpRequest();
        request.open("POST", url, true);
        request.setRequestHeader("Content-Type", "text/json");
        request.setRequestHeader("Content-Length", body.length);
        request.onreadystatechange = function (event) {
            if (request.readyState == 4) {
                var result = "";
                if (request.responseText.length > 0) {
                    var result = JSON.parse(request.responseText);
                    callback(result);
                }
            }
        }
        request.send(body);
    },
    
    finished: function() {
        if (arguments.length < 3) return;
        
        var requestName = arguments[0];
        var functionName = arguments[1];
        var args = arguments[2];
        var url = SYS_URL_PREFIX + "/" + requestName + "/" + functionName;
        var body = JSON.stringify(args);
        
        var request = new XMLHttpRequest();
        request.open("POST", url, true);
        request.setRequestHeader("Content-Type", "text/json");
        request.setRequestHeader("Content-Length", body.length);
        request.onreadystatechange = function (event) {
            //ignore response
        }
        request.send(body);
    },
    
    syncrequest: function() {
        if (arguments.length < 3) return;
    
        var requestName = arguments[0];
        var functionName = arguments[1];
        var args = arguments[2];
        var url = SYS_URL_PREFIX + "/" + requestName + "/" + functionName;
        var body = JSON.stringify(args);
    
        var request = new XMLHttpRequest();
        request.open("POST", url, false);
        request.setRequestHeader("Content-Type", "text/json");
        request.setRequestHeader("Content-Length", body.length);
        request.onreadystatechange = function (event) {
        //ignore response
        }
        request.send(body);
    },
    
    getData: function() {
        if (arguments.length < 4) return;
    
        var url = arguments[0];
        var method = arguments[1];
        var args = arguments[2];
        var callback = arguments[3];
        var body = JSON.stringify(args);
    
        var request = new XMLHttpRequest();
        if (method == 'POST') {
            request.setRequestHeader("Content-Type", "text/json");
            request.setRequestHeader("Content-Length", body.length);
        }
        request.open(method, url, true);
        
        request.onreadystatechange = function (event) {
            var result;
            if (request.readyState == 4) {
                if (request.status == 200) {
                    if (request.responseText.length > 0) {
                        result = {"status" : "ok", "response" : JSON.parse(request.responseText)};
                    }
                    else {
                        result = {"status" : "failed", "text" : "The response text is empty"};
                    }
                }
                else {
                    result = {"status" : "failed", "text" : request.statusText};
                }
            }
            callback(result);
        }
        request.send(body);
    }
};
