/************************************************************************/
/* Global variables                                                     */
/************************************************************************/
var g_nPage = 0; // Number of pages
var g_winWidth = 0; // With of ebook screen
var g_Zoomfactor = 0; // Zoom factor
var highlightId = ""; // current highlight id
var g_selectorToChangeFontFamily = 'span, p, div, a'; // Selector of element will change font-family
/************************************************************************/
/* Init function, will package all init condition to this func          */
/************************************************************************/
function InitViewer() {
    $("a").click(function (e) {
                 e.preventDefault();
                 if (window['jsNavigator'] == undefined) return;
                 if ($(this).attr("href").indexOf("#") == 0) {
                 /* internal link, find the target, convert offset to page and navigate */
                 var target = $(this).closest("div.chapter-container").find("a[name=" + $(this).attr("href").replace(/#/, "") + "]:first");
                 if (target.length > 0) {
                 jsNavigator.GoToPage(offsetLeftToPage(target.offset().left)); // navigate by using slider
                 }
                 
                 } else if ($(this).attr("href").indexOf("http://") == 0 || $(this).attr("href").indexOf("https://") == 0) {
                 /* Send back to c# to open in browser */
                 jsNavigator.GoToExternalUrl($(this).attr("href"));
                 } else if ($("a[name=" + $(this).attr("href").replace(/#/, "") + "]:first").length > 0) {
                 jsNavigator.GoToPage(offsetLeftToPage($("a[name=" + $(this).attr("href").replace(/#/, "") + "]:first").offset().left)); // navigate by using slider
                 }
                 /* If not internal or external http(s) link, just ignore */
                 });
    var a = document.getElementsByTagName("*");
    for (var i = 0; i < a.length; i++) {
        a[i].onkeydown = function (e) {
            var keyCode = ('which' in e) ? e.which : e.keyCode;
            if (keyCode == 9) {// TAB
                e.preventDefault();
            }
            if (keyCode == 33) {// PAGE UP
                e.stopPropagation();
                e.preventDefault();
                jsNavigator.GoToNextPage($(this).prop("tagName"));
                $("div.div-note-input").find("textarea").blur();
            }
            if (keyCode == 34) {//PAGE DOWN
                e.stopPropagation();
                e.preventDefault();
                jsNavigator.GoToPreviousPage($(this).prop("tagName"));
                $("div.div-note-input").find("textarea").blur();
            }
        }
    }
    /* Set default font-family */
    $(g_selectorToChangeFontFamily).each(function () {
                                         $(this).attr("default-font-family",$(this).css("font-family"));
                                         });
}

/************************************************************************/
/* Setup main reader screen                                             */
/************************************************************************/
function SetupDoublePageOnScreen() {
    
    winWidth = parseInt($(window).width());
    if (winWidth % 2 == 0) {
        winWidth += 16;
    } else {
        winWidth += 17;
    }
    winHeight = parseInt($(window).height());
    
    var d = document.getElementsByTagName('body')[0];
    
    d.style.overflow = 'hidden';
    
    docHeight = d.offsetHeight;
    nPage = Math.floor(docHeight / winHeight) + 1;
    
    d.style.height = (winHeight - 30) + 'px';
    
    d.style.WebkitColumnCount = nPage;
    d.style.WebkitColumnWidth = Math.floor(winWidth / 2 - 100) + 'px';
    
    d.style.WebkitColumnRuleColor = '#BFC9D9';
    d.style.WebkitColumnRuleStyle = 'solid';
    d.style.WebkitColumnRuleWidth = '1px';
    d.style.WebkitColumnGap = '100px';
    
    d.style.width = ($(document).width()) + 'px';
    
    d.style.paddingLeft = '50px';
    d.style.paddingRight = '50px';
    
    g_nPage = Math.ceil(document.getElementsByTagName('body')[0].scrollWidth / winWidth);
    g_winWidth = winWidth;
}

/************************************************************************/
/* Go to a specific page                                                */
/************************************************************************/
function GoToPage(iPage) {
    if (iPage > g_nPage) iPage = g_nPage;
    var d = document.getElementsByTagName('body')[0];
    d.style.marginLeft = -(iPage * g_winWidth) + 'px';
}

function openFootNote(idFootNote){
    JsToObjC.doAction('openFootNote:', idFootNote);
}
/************************************************************************/
/* get current viewing page based on margin of body                     */
/************************************************************************/
function getCurrentPage() {
    var d = document.getElementsByTagName('body')[0];
    var n = -parseInt(d.style.marginLeft.replace("px", ""));
    return Math.ceil(n / g_winWidth);
}

/************************************************************************/
/* Reset screen with current document content,                          */
/* 1 column with vertical scrollbar                                     */
/************************************************************************/
function ResetScreen() {
    
    /*
     var d = document.getElementsByTagName('body')[0];
     
     d.style.WebkitColumnCount = '';
     d.style.WebkitColumnWidth = '';
     d.style.width = '';
     d.style.height = '';
     */
}
/************************************************************************/
/* Convert left offset in pixel to page                                 */
/************************************************************************/
function offsetLeftToPage(left) {
    var m = document.getElementsByTagName("body")[0].style.marginLeft.replace("px", "");
    if (m != "") {
        m = parseFloat(m);
    }
    else {
        m = 0;
    }
    left = left - m;
    
    return Math.ceil(left / g_winWidth);
}

function myoffsetLeftToPage(left) {
    var m = document.getElementsByTagName("body").item(0).style.marginLeft.replace("px", "");
    if (m != "") {
        m = parseFloat(m);
    }
    else {
        m = 0;
    }
    left = left - m;
	
	var d = document.getElementsByTagName('body').item(0);
	var winWidth = parseInt($(window).width());
    //	if (winWidth % 2 == 0) {winWidth += 16;}
    //	else {winWidth += 17;}
    return Math.ceil(left / winWidth);
}
/************************************************************************/
/* get page by class                                                    */
/************************************************************************/
function getPageByClass(id) {
    if ($("." + id).length <= 0) return 0;
    return myoffsetLeftToPage($("." + id + ":first").offset().left);
}
/************************************************************************/
/* Get page number by specific element id                               */
/************************************************************************/
function getPageById(id) {
    if ($("#" + id).length <= 0) return 0;
    return myoffsetLeftToPage($("#" + id + ":first").offset().left);
}
/************************************************************************/
/* Searching in html text content                                    */
/************************************************************************/
function epubSearch(query) {
    var d = document.getElementsByTagName("body").item(0);
    var re = new RegExp(query, "gi");
    var re0 = new RegExp("[>][^><]*[><]", "gi");
    
    d.innerHTML = d.innerHTML.replace(re0, function (text) {
                                      return text.replace(re, "<highlight class=\"2light\" style=\"background-color:yellow;\">$&</highlight>");
                                      });
    
    var result = [];
    $(".2light").each(function () {
                      var o = $(this).offset();
                      
                      var r = new Object();
                      r.left = o.left;
                      r.top = o.top;
                      
                      //r.page = offsetLeftToPage(o.left);
                      r.page = myoffsetLeftToPage(o.left);
                      //r.preText = $(this).parent().text();
                      r.preText = $(this).text();
                      var temp = this.previousSibling;
                      if (temp != null) {
                      temp = temp.textContent;
                      if (temp.length > 20 && temp.lastIndexOf(" ", temp.length - 20) != -1) {
                      r.preText = temp.substring(temp.lastIndexOf(" ", temp.length - 20)) + r.preText;
                      } else {
                      r.preText = temp + r.preText;
                      }
                      }
                      temp = this.nextSibling;
                      if (temp != null) {
                      temp = temp.textContent;
                      if (temp.length > 20 && temp.indexOf(" ", 20) != -1) {
                      r.preText = r.preText + temp.substring(0,temp.indexOf(" ", 20));
                      } else {
                      r.preText = r.preText + temp;
                      }
                      }
                      
                      result.push(r);
                      });
    
    //re = new RegExp("<highlight class=\"2light\" style=\"background-color:yellow;\">(.*?)</highlight>", "gi");
    //d.innerHTML = d.innerHTML.replace(re, "$1");
    
    return result;
}
/************************************************************************/
/* Clean search result                                                  */
/************************************************************************/
function CleanSearchResult() {
    if ($(".2light").length > 0) {
        var d = document.getElementsByTagName("body").item(0);
        re = new RegExp("<highlight class=\"2light\" style=\"background-color:yellow;\">(.*?)</highlight>", "gi");
        d.innerHTML = d.innerHTML.replace(re, "$1");
    }
}

/************************************************************************/
/* Initial font size for zoom                                           */
/************************************************************************/
function InitFontSize() {
    var b = document.body;
    if (!b.style.fontSize || b.style.fontSize == "") b.style.fontSize = "16px"; // Default fontSize
    setFontSize(b);
    //return;
    var a = document.getElementsByTagName("body")[0].getElementsByTagName("*");
    for (var i = 0; i < a.length; i++) {
        a[i].setAttribute('default-font-size', a[i].style.fontSize);
        var v = document.defaultView.getComputedStyle(a[i], null).getPropertyValue("line-height");
        var s = parseFloat(v.replace(/em|pt|px|%/gi, ''));
        a[i].style.lineHeight = s + "px";
        a[i].setAttribute('default-line-height', s + "px");
    }
}
/************************************************************************/
/* parentFontSize must be in pixel                                      */
/* return font size as text in pixel                                    */
/************************************************************************/
function calculateFontSize(currentFontSize, parentFontSize) {
    currentFontSize = currentFontSize.toLowerCase();
    parentFontSize = parentFontSize.toLowerCase();
    var ps = parseFloat(parentFontSize.replace("px", ""));
    var cs = 0;
    if (currentFontSize.indexOf("pt") >= 0) {
        return (parseFloat(currentFontSize.replace("pt", "")) / 0.75) + "px";
    } else if (currentFontSize.indexOf("em") >= 0) {
        cs = parseFloat(parentFontSize.replace("em", ""));
        return (ps * cs) + "px";
    } else if (currentFontSize.indexOf("%") >= 0) {
        cs = parseFloat(parentFontSize.replace("%", ""));
        return ((ps * cs) / 100) + "px";
    } else if (currentFontSize.indexOf("px") >= 0) {
        return currentFontSize;
    }
    return parentFontSize; // Unknown unit, set the same as parent
}
/************************************************************************/
/* set default font-size to style for all node child                    */
/************************************************************************/
function setFontSize(node) {
    if (node.nodeType == 3) return; // #textNode
    var cc = node.firstChild;
    while (cc != null) {
        if (cc.nodeType == 3) {
            cc = cc.nextSibling;
            continue; // #textNode again;
        }
        
        if (!cc.style.fontSize || cc.style.fontSize == "") {
            cc.style.fontSize = node.style.fontSize;
        } else {
            cc.style.fontSize = calculateFontSize(cc.style.fontSize, node.style.fontSize);
        }
        
        setFontSize(cc);
        
        cc = cc.nextSibling;
    }
}
/************************************************************************/
/* Change font size of whole document by step                           */
/************************************************************************/
function ChangeFontSize(step) {
    var currentPage = getCurrentPage();
    GoToPage(1);
    /* Do zooming */
    var d = document.getElementsByTagName("body")[0];
    var a = d.getElementsByTagName("*");
    for (var i = 0; i < a.length; i++) {
        var s = parseFloat(a[i].style.fontSize.replace(/em|pt|px|%/gi, ''));
        s = s + step;
        a[i].style.fontSize = s + "px";
        s = parseFloat(a[i].style.lineHeight.replace(/em|pt|px|%/gi, ''));
        s = s + step;
        a[i].style.lineHeight = s + "px";
    }
    /* re calculate num page */
    calculateNumPage();
    GoToPage(currentPage);
    
    /* update z00m factor */
    if (step > 0) {
        g_Zoomfactor++;
    }
    else if (step < 0) {
        g_Zoomfactor--;
    }
}
/************************************************************************/
/* Reset whole document font-size to default                            */
/************************************************************************/
function ResetFontSize() {
    var currentPage = getCurrentPage();
    GoToPage(1);
    /* do reset */
    var d = document.getElementsByTagName("body")[0];
    var a = d.getElementsByTagName("*");
    for (var i = 0; i < a.length; i++) {
        var s = a[i].getAttribute('default-font-size');
        a[i].style.fontSize = s;
        s = a[i].getAttribute('default-line-height');
        a[i].style.lineHeight = s;
    }
    /* recalculate num page */
    calculateNumPage();
    GoToPage(currentPage);
    /* update z00m factor */
    g_Zoomfactor = 0;
}
/************************************************************************/
/* Compare node contain or equal, use in highlight                      */
/************************************************************************/
function containsOrEqual(p, c) {
    if (p.contains && p.contains(c)) return true;
    if (p == c) return true;
    return false;
}
/************************************************************************/
/* Perform highlight from starContainer@startOffset to endContainer@endOffset
 /* commonAncestorContainer is nearest node contain both startContainer & endContainer
 /************************************************************************/
function highlight(startContainer, startOffset, endContainer, endOffset, commonAncestorContainer, hlType) {
    /* add affect of <highlight> to node position & offset */
    var left = startContainer;
	
    JsToObjC.printLog("highlight startContainer:" + this.objToString(startContainer));
    JsToObjC.printLog("highlight endContainer:" + this.objToString(endContainer));
    while (left.previousSibling != null && (left.previousSibling.nodeType == 3 || left.previousSibling.nodeName.toLowerCase() == "highlight"))
        left = left.previousSibling;
    while (left.nodeType == 3 || left.nodeName.toLowerCase() == "highlight") { /* traverse to right until end of original text node */
        var l = 0;
        if (left.nodeName.toLowerCase() == "highlight" && l.firstChild != null) l = left.firstChild.length;
        if (left.nodeType == 3) l = left.length;
        
        if (l > startOffset) {
            startContainer = left;break;
        } else {
            startOffset = startOffset - l;
        }
        
            left = left.nextSibling;
    }
    left = endContainer;
    while (left.previousSibling != null && (left.previousSibling.nodeType == 3 || left.previousSibling.nodeName.toLowerCase() == "highlight"))
        left = left.previousSibling;
    while (left.nodeType == 3 || left.nodeName.toLowerCase() == "highlight") { /* traverse to right until end of original text node */
        var l = 0;
        if (left.nodeName.toLowerCase() == "highlight" && left.firstChild != null)
        	l = left.firstChild.length;
        if (left.nodeType == 3) l = left.length;
        
        if (l > endOffset) {
            endContainer = left;break;
        } else {
            endOffset = endOffset - l;
        }
        if (left.nextSibling != null) {
            left = left.nextSibling;
        } else {
            endOffset = l;
            break;
        }
    }
    
    if (startContainer == endContainer) {
        var s2 = startContainer.splitText(startOffset);
        var s3 = s2.splitText(endOffset - startOffset);
        var ns = document.createElement('highlight');
        ns.className = highlightId;
        ns.setAttribute("type", hlType);
        ns.innerHTML = s2.nodeValue;
        startContainer.parentNode.replaceChild(ns, s2);
        
        return;
    }
    
    var pp = commonAncestorContainer;
    var cc;
    var s = startContainer.parentNode;
    var e = endContainer.parentNode;
    if (containsOrEqual(pp, s) && containsOrEqual(pp, e)) {
        cc = pp.childNodes;
        var flag = false;
        for (var i = 0; i < cc.length; i++) {
            if ((cc[i].contains && cc[i].contains(e)) || cc[i] == endContainer) break;
            if (flag) {
                textnodes(cc[i], hlType);
            } else if (cc[i].contains && cc[i].contains(s)) {
                flag = true;
            } else if (startContainer == cc[i]) {
                flag = true;
            }
        }
    }
    
    cc = startContainer;
    pp = cc.parentNode;
//    while (pp != commonAncestorContainer) {
//        var ps = cc.nextSibling;
//        while (ps != null) {
//            var t = ps.nextSibling;
//            textnodes(ps, hlType);
//            ps = t;
//        }
//        if (pp == null) break;
//        cc = pp;
//        pp = cc.parentNode;
//    }
//    
//    cc = endContainer;
//    pp = cc.parentNode;
//    while (pp != commonAncestorContainer) {
//        var ps = cc.previousSibling;
//        while (ps != null) {
//            var t = ps.previousSibling;
//            textnodes(ps, hlType);
//            ps = t;
//        }
//        if (pp == null) break;
//        cc = pp;
//        pp = cc.parentNode;
//    }
    
    if (startContainer.nodeType == 3) // text node
    {
        var st = startContainer.splitText(startOffset);
        
        var n_st = document.createElement('highlight');
        n_st.className = highlightId;
        n_st.setAttribute("type", hlType);
        n_st.innerHTML = st.nodeValue;
        
        startContainer.parentNode.replaceChild(n_st, st);
    }
    //highlight last part in end container
    if (endContainer.nodeType == 3) {
        var p = endContainer.splitText(endOffset);
        
        st = p.previousSibling;
        n_st = document.createElement('highlight');
        n_st.className = highlightId;
        n_st.setAttribute("type", hlType);
        n_st.innerHTML = st.nodeValue;
        
        p.parentNode.replaceChild(n_st, st);
    }
    
    highlightId = "";
}
/************************************************************************/
/* Highlight all text node in n                                         */
/************************************************************************/
function textnodes(n, hlType) {
    function iterate(node) {
        var nodes = node.childNodes;
        var len = nodes.length;
        for (var a = 0; a < len; a++) {
            if (nodes[a].nodeType == 3) {
                if (!nodes[a].nodeValue.match(/^[\s]*$/)) {
                    var ns = document.createElement('highlight');
                    ns.className = highlightId;
                    ns.setAttribute("type", hlType);
                    ns.innerHTML = nodes[a].nodeValue;
                    node.replaceChild(ns, nodes[a]);
                }
            }
            else {
                if (nodes[a].nodeName.toLowerCase() != "script") {
                    iterate(nodes[a]);
                }
            }
        }
    }
    if (n.nodeType == 3) {
        if (!n.nodeValue.match(/^[\s]*$/)) {
            var ns = document.createElement('highlight');
            ns.className = highlightId;
            ns.setAttribute("type", hlType);
            ns.innerHTML = n.nodeValue;
            n.parentNode.replaceChild(ns, n);
        }
    }
    else {
        iterate(n);
    }
}

function objToString (obj) {
    var str = '';
    for (var p in obj) {
        if (obj.hasOwnProperty(p)) {
            str += p + '::' + obj[p] + '\n';
        }
    }
    return str;
}
/************************************************************************/
/* Highlight selected content
 /************************************************************************/
function highlightSelectedContent(id, highlightType) {
    if (getSelectedTextStatus() != 0) { return null; }
    highlightId = id;
    if (window.getSelection().rangeCount > 0) {
        var r = window.getSelection().getRangeAt(0);
        JsToObjC.printLog("highightSelectedContent:: window.getSelection().getRangeAt(0) = " + this.objToString(r));
        /* return object (r.startContainer, r.startOffset, r.endContainer, r.endOffset, r.commonAncestorContainer) to archive */
        var o = new Object();
        o.commonAncestorContainer = NodeSerialize(r.commonAncestorContainer);
        
        var l = 0;
        var left = r.startContainer;
    	JsToObjC.printLog("highightSelectedContent:: r.startContainer = " + this.objToString(r.startContainer));
        JsToObjC.printLog("highightSelectedContent:: r.endContainer = " + this.objToString(r.endContainer));
        JsToObjC.printLog("left.previousSibling = " + this.objToString(left.previousSibling));
        
        while (left.previousSibling != null && (left.previousSibling.nodeType == 3 || left.previousSibling.nodeName.toLowerCase() == "highlight")) {
        	left = left.previousSibling;
            JsToObjC.printLog("startcontainer  = left.previousSibling in while = " + this.objToString(left.previousSibling));
        }
    	JsToObjC.printLog("highightSelectedContent:: startcontainer after while = " + this.objToString(left));
        var startContainer = left;
        while (left.nodeType == 3 || left.nodeName.toLowerCase() == "highlight") { /* traverse to right until end of original text node */
            if ((left == r.startContainer || left.length == 0)) {
            	JsToObjC.printLog("highightSelectedContent:: break due to \n left.length = " + left.length);
                if (left == r.startContainer) {
                    JsToObjC.printLog("\n\t\t " + this.objToString(left) + "\n");
                }
                break;
            } else {
                if (left.nodeName.toLowerCase() == "highlight") {
                    if (left.firstChild != null)
                        l = l + left.firstChild.length;
                	JsToObjC.printLog("highightSelectedContent:: l1 = " + l);
                } else {
                    if (left.length != null)
                        l = l + left.length;
                	JsToObjC.printLog("highightSelectedContent:: l2 = " + l);
                }
            }
            left = left.nextSibling;
            JsToObjC.printLog("startcontainer  = nextSibling in while = " + this.objToString(left));
            if (left == null)
                break;
        }
        o.startOffset = l + r.startOffset;
        JsToObjC.printLog("startOffset  = " + o.startOffset);
        left = r.endContainer;
        l = 0;
        while (left.previousSibling != null && (left.previousSibling.nodeType == 3 || left.previousSibling.nodeName.toLowerCase() == "highlight")) left = left.previousSibling;
        var endContainer = left;
        while (left != null && (left.nodeType == 3 || left.nodeName.toLowerCase() == "highlight")) { /* traverse to right until end of original text node */
            if ((left == r.endContainer || left.length == 0)) {
                break;
            } else {
                if (left.nodeName.toLowerCase() == "highlight") {
                    if (left.firstChild != null)
                        l = l + left.firstChild.length;
                } else {
                    if (left.length != null)
                        l = l + left.length;
                }
            }
            
            left = left.nextSibling;
        }
        o.endOffset = l + r.endOffset;

        o.startContainer = NodeSerialize(startContainer);
        o.endContainer = NodeSerialize(endContainer);
        
    	JsToObjC.printLog("highightSelectedContent:: startContainer = " + startContainer);
    	JsToObjC.printLog("highightSelectedContent:: endContainer = " + endContainer);
        highlight(startContainer, o.startOffset, endContainer, o.endOffset, r.commonAncestorContainer, highlightType);
        
        JsToObjC.printLog("highightSelectedContent:: o = " + this.objToString(o));
        return o;
    }
    return null;
}
/************************************************************************/
/* Highlight by archived data                                           */
/************************************************************************/
function highlightItem(id, startContainer, startOffset, endContainer, endOffset, commonAncestorContainer) {
    highlightId = id;
    startContainer = NodeDeserialize(startContainer);
    endContainer = NodeDeserialize(endContainer);
    commonAncestorContainer = NodeDeserialize(commonAncestorContainer);
    if (startContainer == null || endContainer == null || commonAncestorContainer == null) return false;
    highlight(startContainer, startOffset, endContainer, endOffset, commonAncestorContainer, "highlight");
    return true;
}

function doHighlight(id, highlightType, hlType){
	var objHightlight = highlightSelectedContent(id, highlightType);
	updateHighlightType(id, hlType);
    return objHightlight.startContainer + '&' + objHightlight.endContainer + '&' + objHightlight.startOffset + '&' + objHightlight.endOffset + '&' + objHightlight.commonAncestorContainer + '&' + hlType;
    
}

function doNote(id, highlightType, hlType){
	var objHightlight = highlightSelectedContent(id, highlightType);
	updateHighlightType(id, hlType);
    //JsToObjC.printLog("doNote:: objHightlight = " + this.objToString(objHightlight));
    return objHightlight.startContainer + '&' + objHightlight.endContainer + '&' + objHightlight.startOffset + '&' + objHightlight.endOffset + '&' + objHightlight.commonAncestorContainer + '&' + hlType;
    
}

/************************************************************************/
/* Translate Node to array as path from body to Node                    */
/************************************************************************/
function NodeSerialize(node) {
    var str = "";
    if (node.nodeType == 3) {
        /* If #textNode, handle to avoid current node is splited by <highlight> */
        var pp = node.parentNode.firstChild;
        var f = false;
        var i = 0;
        while (pp != null) {
            if (pp == node) {
                break;
            }
            if (f) {
                if (pp.nodeType == 3 || pp.nodeName.toLowerCase() == "highlight") {
                    f = true;
                }
            } else {
                if (pp.nodeType != 3 && pp.nodeName.toLowerCase() != "highlight") {
                    f = false;
                    i++;
                }
            }
            
            pp = pp.nextSibling;
        }
        
        str =  node.nodeName + ":" + node.nodeType + ":" + i + ";" + str;
        
        node = node.parentNode;
        while (node.nodeName.toLowerCase() == "highlight") node = node.parentNode;
    }
    
    while (!node.nodeName || node.nodeName.toLowerCase() != "body") {
        var pp = node.parentNode;
        var ir = pp.firstChild;
        var p = 0;
        while (ir != null) {
            if (ir == node) {
                break;
            }
            if (ir.nodeType == node.nodeType) {
                if (!ir.nodeName && !node.nodeName) {
                    p++;
                } else if (ir.nodeName && node.nodeName && ir.nodeName == node.nodeName) {
                    p++;
                }
            }
            ir = ir.nextSibling;
        }
        var name = "";
        if (node.nodeName) { name = node.nodeName; }
        str = name + ":" + node.nodeType + ":" + p + ";" + str;
        node = node.parentNode;
    }
    return str;
}
/************************************************************************/
/* Translate array from NodeSerialized string to Node                   */
/************************************************************************/
function NodeDeserialize(str) {
    var pp = document.getElementsByTagName("body").item(0); /* start from body */
    var nodes = str.replace(/[;]*$/, '').split(";"); /* trim ";" before split */
    for (var index = 0; index < nodes.length; index++) {
        var arr = nodes[index].split(":");
        var node = pp.firstChild;
        var p = 0;
        
        if (arr[1] == 3 || arr[0].toLowerCase() == "highlight") {
            /* if inspecting last node (#text or highlight) */
            var f = false;
            var i = 0;
            while (node != null) {
                if (i == arr[2] && (node.nodeName.toLowerCase() == "highlight" || arr[1] == 3)) {
                    break;
                }
                if (f) {
                    if (node.nodeType == 3 || node.nodeName.toLowerCase() == "highlight") {
                        f = true;
                    }
                } else {
                    if (node.nodeType != 3 && node.nodeName.toLowerCase() != "highlight") {
                        f = false;
                        i++;
                    }
                }
                node = node.nextSibling;
            }
            return node;
        }
        
        while (node != null) {
            if (node.nodeType == arr[1]) {
                if ((arr[0] == "" && !node.nodeName) || (node.nodeName && arr[0] == node.nodeName)) {
                    if (p == arr[2]) {
                        pp = node;
                        break;
                    } else {
                        p++;
                    }
                }
            }
            node = node.nextSibling;
        }
        
        if (node == null) {
            return null;
        }
    }
    return pp;
}


function NodeDeserializeNAM(str) {
    var pp = document.getElementsByTagName("body").item(0); /* start from body */
    //str = str.toLowerCase();
    JsToObjC.printLog("NodeDeserialize , str.replace(/[;]*$/, '') : " + str.replace(/[;]*$/, ''));
    var nodes = str.replace(/[;]*$/, '').split(";"); /* trim ";" before split */
    for (var index = 0; index < nodes.length; index++) {
        JsToObjC.printLog("NodeDeserialize , handle text : " + nodes[index]);
        var arr = nodes[index].split(":");
        var node = pp.firstChild;
        var p = 0;
        
        if (arr[1] == 3 || arr[0].toLowerCase() == "highlight") {
            /* if inspecting last node (#text or highlight) */
            var f = false;
            var i = 0;
            while (node != null) {
                if (i == arr[2] && (node.nodeName.toLowerCase() == "highlight" || arr[1] == 3)) {
                    break;
                }
                if (f) {
                    if (node.nodeType == 3 || node.nodeName.toLowerCase() == "highlight") {
                        f = true;
                    }
                } else {
                    if (node.nodeType != 3 && node.nodeName.toLowerCase() != "highlight") {
                        f = false;
                        i++;
                    }
                }
                node = node.nextSibling;
            }
            return node;
        }
        
        while (node != null) {
            JsToObjC.printLog("handle node: " + this.objToString(node));
            if (node.nodeType == arr[1]) {
                if ((arr[0] == "" && !node.nodeName) || (node.nodeName && arr[0] == node.nodeName)) {
                    if (p == arr[2]) {
                        pp = node;
                        break;
                    } else {
                        p++;
                    }
                }
            }
            node = node.nextSibling;
        }
        
        if (node == null) {
            return null;
        }
    }
    return pp;
}
/************************************************************************/
/* Remove highlight with specific id(class)                             */
/************************************************************************/
function removeHighlight(id) {
    var t = $("." + id).contents().unwrap();
    for (var i = 0; i < t.length; i++) {
        if (t[i] != null && t[i].parentNode != null) {
            t[i].parentNode.normalize();
        }
    }
}
/************************************************************************/
/* remove all highlight and node                                        */
/************************************************************************/
function removeAllHighlightAndNode() {
    var t = $("highlight").contents().unwrap();
    for (var i = 0; i < t.length; i++) {
        if (t[i] != null && t[i].parentNode != null) {
            t[i].parentNode.normalize();
        }
    }
}

/************************************************************************/
/* Remove selected highlight                       )                    */
/************************************************************************/
function removeSelectedHighlight(highlightType) {
    if (getSelectedTextStatus() <= 0) { return null; }
    var r = window.getSelection().getRangeAt(0);
    var s = document.createElement("span");
    
    s.appendChild(r.cloneContents());
    var c = new Array();
    $(s).find("highlight[type=" + highlightType + "]").each(function () {
                                                            var e = false;
                                                            var cc = $(this).attr("class");
                                                            for (var i = 0; i < c.length; i++) {
                                                            if (c[i] == cc) { e = true; break; }
                                                            }
                                                            if (!e) { c.push(cc); }
                                                            });
    
    if (r.startContainer.nodeType == 3) {
        if (r.startContainer.parentNode.nodeName.toLowerCase() == "highlight") {
            var e = false;
            var cc = $(r.startContainer.parentNode).attr("class");
            for (var i = 0; i < c.length; i++) {
                if (c[i] == cc) { e = true; break; }
            }
            if (!e) { c.push(cc); }
        }
    }
    
    if (r.endContainer.nodeType == 3) {
        if (r.endContainer.parentNode.nodeName.toLowerCase() == "highlight") {
            var e = false;
            var cc = $(r.endContainer.parentNode).attr("class");
            for (var i = 0; i < c.length; i++) {
                if (c[i] == cc) { e = true; break; }
            }
            if (!e) { c.push(cc); }
        }
    }
    
    for (var i = 0; i < c.length; i++) {
        removeHighlight(c[i]);
    }
    
    return c;
}
/************************************************************************/
/* Checking selected text status                                        */
/* return -3 Unknown error                                              */
/*        -2 No selection                                               */
/*        -1 Selection has no text                                      */
/*         0 Selection is free, no highlight nor note                   */
/*         1 Selection contains highlight                               */
/*         2 Selection contains note                                    */
/*         3 Selection contain both highlight and text                  */
/************************************************************************/
function getSelectedTextStatus() {
    /* remove search result */
    CleanSearchResult();
    /* check */
    if (window.getSelection().rangeCount <= 0) return -2;
    
    var r = window.getSelection().getRangeAt(0);
    var s = document.createElement('span');
    s.appendChild(r.cloneContents());
    if (s.innerText == undefined || s.innerText == "") return -1;
    
    if (r.startContainer == r.endContainer && r.endContainer.nodeType == 3) {
        if (r.startContainer.parentNode.nodeName.toLowerCase() != "highlight") return 0;
        if (r.startContainer.parentNode.getAttribute("type") == "highlight") return 1;
        if (r.startContainer.parentNode.getAttribute("type") == "note") return 2;
    } else {
        if ($(s).find("highlight[type=note]").length > 0 && $(s).find("highlight[type=highlight]").length > 0) return 3;
        if ($(s).find("highlight[type=highlight]").length > 0) return 1;
        if ($(s).find("highlight[type=note]").length > 0) return 2;
        
        return 0;
    }
    
    return -3;// I dont know what happen :D
}

/************************************************************************/
/* Checking selected range on browser is highlighted ?                  */
/* Out of date, using getSelectedTextStatus instead                     */
/************************************************************************/
function isSelectedTextHighlighted() {
    if (window.getSelection().rangeCount > 0) {
        var r = window.getSelection().getRangeAt(0);
        var s = document.createElement('span');
        s.appendChild(r.cloneContents());
        if (r.startContainer == r.endContainer && r.endContainer.nodeType == 3) {
            if (r.startContainer.parentNode.nodeName.toLowerCase() == "highlight") {
                return 1;
            } else {
                return 0;
            }
        } else {
            if (s.innerHTML.indexOf("<highlight") >= 0 || s.innerHTML.indexOf("</highlight>") >= 0) {
                return 1;
            } else {
                return 0;
            }
        }
    }
    return -1;
}
/************************************************************************/
/* Pop up an input box to note to selected text                         */
/************************************************************************/
function noteSelectedText(id) {
    if (getSelectedTextStatus() != 0) return null;
    var o = highlightSelectedContent(id,"note");
    displayNoteInput(id, "");
    return o;/* return highlight item ~ note item without note content. Note content will be updated when note input dismissed */
}
/************************************************************************/
/* Add an archived note item to document                                */
/************************************************************************/
function addNoteItem(id, startContainer, startOffset, endContainer, endOffset, commonAncestorContainer, noteContent) {
    highlightId = id;
    startContainer = NodeDeserialize(startContainer);
    endContainer = NodeDeserialize(endContainer);
    commonAncestorContainer = NodeDeserialize(commonAncestorContainer);
    if (startContainer == null || endContainer == null || commonAncestorContainer == null) return false;
    highlight(startContainer, startOffset, endContainer, endOffset, commonAncestorContainer, "note");
    
    $("highlight." + id + ":first").attr("note-content", noteContent.replace(/<br\/>/g,"\n"));
    attachNoteTooltip(id);
    
    return true;
}
/************************************************************************/
/* Attach note tooltip to all highlight with specific id                */
/************************************************************************/
function attachNoteTooltip(id) {
    var hs = document.getElementsByTagName("highlight");
    for (var i = 0; i < hs.length; i++) {
        if (hs[i].className == id) {
            hs[i].onmouseover = function() {
                if (!noteParam.allowPop) return;
                noteParam.FocusNoteInput();
                displayNoteInput(id, $("highlight." + id + ":first").attr("note-content"));
            };
            hs[i].onmouseout = function() { /* concern, if textarea.onblur always close noteInput */
                removeNoteInput(id);
            };
        }
    }
}
/************************************************************************/
/* Remove Note Input box                                                */
/************************************************************************/
function removeNoteInput(id){
    var d = document.getElementById("note-input-" + id);
    if (d != null) {
        document.body.removeChild(d);
    }
}
/************************************************************************/
/* Display note input box/note box                                      */
/************************************************************************/
function displayNoteInput(id, noteContent) {
    /* if note-input-id already existed, do nothing */
    if ($("div#note-input-" + id).length > 0) return;
    /* show input box for note content */
    var d = document.createElement("div");
    d.id = "note-input-" + id;
    d.className = "div-note-input";
    /* Style for input box */
    d.style.width = "500px";
    d.style.height = "200px";
    d.style.padding = "0px 0px 0px 0px";
    d.style.background = "url(" + NoteStyle.aboveBackground + ")";
    d.style.position = "absolute";
    d.style.opacity = "0.85";
    
    var ta = document.createElement("textarea");
    ta.style.width = "480px";
    ta.style.height = "165px";
    ta.style.margin = "0px 0px 0px 0px";
    ta.style.padding = "10px 10px 10px 10px";
    ta.style.backgroundColor = "transparent";
    ta.style.border = "none";
    ta.style.lineHeight = "26x";
    ta.style.overflow = "hidden";
    
    ta.style.fontFamily = "Courier New";
    ta.style.fontSize = "16pt";
    ta.style.fontWeight = "bold";
    ta.style.opacity = "1";
    
    ta.value = noteContent;
    
    /* Calculate position by selected text */
    var f = $("highlight." + id + ":first");
    d.style.top = "0px";
    d.style.left = "0px";
    if (f != null) {
        d.style.top = (f.offset().top - 205) + "px";
        if ((f.offset().top - 205) <= 0) {
            d.style.top = (f.offset().top + f.height() + 5) + "px";
            d.style.background = "url(" + NoteStyle.belowBackground + ")";
            ta.style.marginTop = "15px";
        }
        d.style.left = (f.offset().left - 250) + "px";
        if ((f.offset().left - 250) <= 0) {
            d.style.left = "5px";
        }
        if ((f.offset().left - 250 + 500) > g_winWidth) {
            d.style.left = (g_winWidth - 505) + "px";
        }
    }
    
    d.appendChild(ta);
    
    /* Save note and remove input box */
    ta.onblur = function() {
        f.attr("note-content", ta.value);
        if (ta.value.replace(/\n|\s/g, "") == "") {
            noteParam.UpdateNote(id, "");
            removeHighlight(id);
        } else {
            noteParam.UpdateNote(id, ta.value.replace(/\n/g, "<br/>"));
            attachNoteTooltip(id);
        }
        document.body.removeChild(d);
    };
    
    document.body.appendChild(d);
    ta.focus();
}

function updateHighlightType(id, hlType) {
    $("highlight." + id).attr("hltype", hlType);
}

/************************************************************************/
/* Change font family                                                   */
/************************************************************************/
function ChangeFontFamily(FontFamily) {
    var currentPage = getCurrentPage();
    GoToPage(1);
    $(g_selectorToChangeFontFamily).css("font-family", FontFamily);
    /* recalculate num page */
    calculateNumPage();
    GoToPage(currentPage);
    
    return g_nPage;
}
/************************************************************************/
/* Reset font-family                                                    */
/************************************************************************/
function ResetFontFamily() {
    var currentPage = getCurrentPage();
    GoToPage(1);
    $(g_selectorToChangeFontFamily).each(function () {
                                         $(this).css("font-family", $(this).attr("default-font-family"));
                                         });
    /* recalculate num page */
    calculateNumPage();
    GoToPage(currentPage);
    
    return g_nPage;
}
/************************************************************************/
/* Re-calculate num page: g_nPage                                       */
/************************************************************************/
function calculateNumPage() {
    var d = document.getElementsByTagName("body")[0];
    var m = d.style.marginLeft.replace("px", "");
    if (m != "") {
        m = parseFloat(m);
    }
    else {
        m = 0;
    }
    
    g_nPage = Math.ceil((d.scrollWidth - m) / g_winWidth);
}

function changePageWidth(width) {
    var element = document.createElement('meta');
    element.name = "viewport";
    element.content = "width=" + width;
    var head = document.getElementsByTagName('head')[0];
    head.appendChild(element);
}

function getSelectionTopLeft() {
    var x = 0, y = 0;
    // Use standards-based method only if Range has getBoundingClientRect
    if (window.getSelection && document.createRange
        && typeof document.createRange().getBoundingClientRect != "undefined") {
        var sel = window.getSelection();
        if (sel.rangeCount > 0) {
            var rect = sel.getRangeAt(0).getBoundingClientRect();
            x = rect.left;
            y = rect.top;
        }
    } else if (document.selection && document.selection.type != "Control") {
        // All versions of IE
        var textRange = document.selection.createRange();
        x = textRange.boundingLeft;
        y = textRange.boundingTop;
    }
    return { x: x, y: y };
}

function getHighlightedString() {
    var text        = window.getSelection();
    var selectedText    = text.anchorNode.textContent.substr(text.anchorOffset, text.focusOffset - text.anchorOffset);
    return selectedText;
}

function getHighlightedStringWithPosition() {
    var text        = window.getSelection();
    var position = getSelectionTopLeft();
    var selectedText    = text.anchorNode.textContent.substr(text.anchorOffset, text.focusOffset - text.anchorOffset);
    return selectedText + '&' + position.x + '&' + position.y;
}

function getChapterPosition(chapters) {
    var chapterList = chapters.split('##$$@@$$##');
	var note, screenPosition;
	var pagePositionList = '';
	for(var i = 0 ; i < chapterList.length ; i++) {
		note = document.getElementById(chapterList[i]);
		screenPosition = note.getBoundingClientRect();
		pagePositionList += screenPosition.left + '&';
	}
	return pagePositionList;
}

function getPositionOfIdOrName(idOrName) {
	var note, screenPosition;
	note = document.getElementById(idOrName);
    if (note == null) {
        note = document.getElementsByName(idOrName);
    }
    screenPosition = note.getBoundingClientRect();
	return screenPosition.left;
}

function gotoNotePage(id, screenWidth) {
    if ($("." + id).length <= 0) return 0;
    return Math.floor($("." + id + ":first").offset().left / screenWidth);
}

var determineFontHeight = function(fontStyle) {
    var body = document.getElementsByTagName("body").item(0);
    var dummy = document.createElement("div");
    var dummyText = document.createTextNode("M");
    dummy.appendChild(dummyText);
    dummy.setAttribute("style", fontStyle);
    body.appendChild(dummy);
    var result = dummy.offsetHeight;
    body.removeChild(dummy);
    return result;
};


function alignChapters(screenWidth) {
    var size = currentFontSize + "%";
    var style = "font-family: " + currentFontFamily + "; font-size: " + size + ";";
    var pixelHeight = determineFontHeight(style);
    var obj, rect;
    var marginTop, pageTop;
    jQuery(function(){
           $("div.chapter-container").each(function() {
                rect = this.getBoundingClientRect();
                pageTop = Math.floor(rect.left / screenWidth);
                if (pageTop > 0) {
                    marginTop = (pageTop + 1)* screenWidth - rect.left;
                    marginTop = (Math.floor(marginTop / pixelHeight) + 1) * pixelHeight;
                    this.setAttribute("style", "margin-top:" + marginTop + "px !important;");
                }
            });
        });
}

function pageScroll(xOffset) {
    window.scroll(xOffset,0);
}

function gotoChapter(chapterId) {
    var leftPos = $("#" + chapterId).offset().left;
    pageScroll(leftPos);
    return leftPos;
}

function gotoAnchor(anchorId, position) {
    var a = document.getElementById(anchorId);
    if (a == null) {
        var arrLink = document.getElementsByName(anchorId);
        if (arrLink.length > 0) {
            a = arrLink[0];
        }
    }
    if (a == null)
        return 0;
    var leftPos = a.getBoundingClientRect().left;
    return leftPos;
}

function openImage(filePath) {
    JsToObjC.doAction('openImage:', filePath);
}
